uniform sampler2D vpos; 
uniform sampler2D tri_v; 
uniform sampler2D tri_id; 
uniform float tri_num;
uniform vec3 rnd;
varying vec2 vTexCoord;

//const float vpos_width = 128.0;
//const float vpos_height = 8.0;

const float tri_v_width = 256.0;
const float tri_v_height = 256.0;

const float tri_id_width = 256.0;
const float tri_id_height = 256.0;



const float experiments_num = tri_id_width*tri_id_height;


float rand(vec2 co)
{
	return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

vec2 ID_2D(float id,float w,float h)
{
	vec2 res;
	res.x = mod(id,w);
	res.y = floor(id/w);

	return res/vec2(w,h);
}

void main()
{
	       
	vec4 txt = texture2D(vpos,vTexCoord).xyzw;
    vec3 pos = txt.xyz;    
	vec3 stp = vec3(0.0);
	float num = tri_num;
float pot=0.0;
vec2 rs = rnd.xy+vTexCoord;

	vec2 v_id=vec2(0.0);
	for(;v_id.y<1.0;v_id.y+=1.0/tri_id_height)
	for(v_id.x=0.0;v_id.x<1.0;v_id.x+=1.0/tri_id_width)
	{
		vec4 tri_id_txt = texture2D(tri_id,v_id).xyzw;
		if(tri_id_txt==vec4(0.0))break;
		
		vec4 tr_v1 = texture2D(tri_v,ID_2D(tri_id_txt.x,tri_v_width,tri_v_height)).xyzw;
		vec4 tr_v2 = texture2D(tri_v,ID_2D(tri_id_txt.y,tri_v_width,tri_v_height)).xyzw;
		vec4 tr_v3 = texture2D(tri_v,ID_2D(tri_id_txt.z,tri_v_width,tri_v_height)).xyzw;

		vec3 stp_i = vec3(0.0);
		float pot_i=0.0;
		vec4 ttt=(tr_v1+tr_v2+tr_v3)/3.0;
		vec3 nv=pos-ttt.xyz;
				
		rs.x=rand(rs);
		rs.y=rand(rs);
			
		float l1=min(rs.x,rs.y);
		float l2=max(rs.x,rs.y);
		float l3=1.0-l2;
		l2 -= l1;
		vec4 dt = tr_v1*l1 + tr_v2*l2 + tr_v3*l3;
		
		
		vec3 tmpv = pos-dt.xyz;
		float ll=length(tmpv);
		stp += tmpv*(dt.w*tri_id_txt.w/(ll*ll*ll));
		pot += dt.w*tri_id_txt.w/ll;
	}

	
	gl_FragColor=vec4(normalize(stp),pot);
	//gl_FragColor=texture2D(tri_v,vec2(0.0)).xyzw;
	

}